//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "math.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "ExPars"
#pragma link "ExFuncs"
#pragma link "parstype"
#pragma link "Vars"
#pragma link "ExClass"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
  this->InitVal=10;
}
void __fastcall _MySum(PParserOperation AnOper)
{
   *(AnOper->Dest) = 0;
   for (int i = 1; i<=AnOper->ArgCnt; i++)
   {
      *(AnOper->Dest) += *((Variant **)AnOper->Args)[i-1];
   }
}
//---------------------------------------------------------------------------
Extended __fastcall _MyAVG(const ArgArray &Params, const int Param_High)
{
  Extended Result = 0;
  for (int i=0; i<=Param_High;i++) Result += (Double) Params[i];
  if (Param_High==-1) return 0;
  else return Result/(Param_High+1);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::ShowResult(TLabel *ALabel, Extended AValue)
{
   if (dynamic_cast<TLabel*> (ALabel)) ((TLabel *)(ALabel))->Caption=FloatToStr(AValue);
}
//---------------------------------------------------------------------------
int __fastcall TForm1::_DemoFunc(const ArgArray &Params, const int Param_High)
{
   return ExParser1->CallFunction("DemoLibFunc", Params, Param_High);
}
//---------------------------------------------------------------------------

Variant __fastcall TForm1::EPVars1VAR1CalcValue(TVariable *Sender)
{
  return 40;
}
//---------------------------------------------------------------------------
Variant __fastcall TForm1::EPRegFuncs1MYPRODEvaluate(
      const ArgArray &Params, const int Param_High)
{
  Double Result=0;
  if (Param_High>=0)
  {
     Result=1;
     for (int i=0; i<=Param_High; i++) Result *= (Double)Params[i];
  }
  return Result;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
   typedef void (TObject:: *pom)();
   typedef void **ppp;
   pom p=(pom)&TForm1::ShowResult;
   EPRegFuncs1->AddFunction("MySum",_MySum, -1, /*Unlimited number of arguments*/"My SUM function",fct_Aggregate);
   EPRegFuncs1->AddStdFunction("MyAVG",_MyAVG, NULL, OPENARRAY(TEPTypesType,(typeArray)),
                               typeExtended, "My AVG function", fct_Aggregate);
   EPRegFuncs1->AddStdFunction("ShowResult",*((ppp)&p), this,
                               OPENARRAY(TEPTypesType,(typeLongInt,typeExtended)), typeVoid ,
                                 "Outputs a value in a label''s caption", fct_Custom);
   p = (pom)&TForm1::_DemoFunc;
   EPRegFuncs1->AddStdFunction("DemoFunc",*((ppp)&p), this,
                               OPENARRAY(TEPTypesType,(typeArray)), typeInteger ,
                               "This demo function simply calls a user defined script function", fct_Custom);
   Table1->Open();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
   ExParser1->EditVariables();
   /*EPVars1.EditVariables;*/
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
   EPUserLib1->Edit();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
   EPUserLib1->IniFile = "";
   //If a Path is not specified, INI file must be in the Windows directory
   EPUserLib1->IniFile = "DEMOLIB.INI";
}
//---------------------------------------------------------------------------

void AddUserLibExpr(TEPExprList *AList, AnsiString AName, AnsiString AExpr)
{
  TStrings *ASrc;
  int AnIdx;
  ASrc = new TStringList;
  try
    {
    ASrc->Add(AExpr);
    if (AList->Find(AName,AnIdx)) AList->Sources[AnIdx]=ASrc;
    else AList->Add(AName,ASrc);
    }
  __finally { delete ASrc; }
}

//---------------------------------------------------------------------------


void __fastcall TForm1::Button6Click(TObject *Sender)
{
  ExParser1->Expression->Assign(Memo1->Lines);
  ResultLbl->Caption = ExParser1->F(OPENARRAY(Variant,(3,2,4)));
}
//---------------------------------------------------------------------------


Variant __fastcall TForm1::ExParser1Variable(TObject *Sender,
      const AnsiString VarName)
{
   int AnIdx;
   if (CompareText(VarName,"x2")==0) return 5;
   else if (CompareText(VarName,"Y2")==0) return 3;
   if (CompareText(VarName,"x2")==0) return 5;
   else if (ExParser1->UsedVariables->Find(VarName,AnIdx))
     return ExParser1->UsedVariables->Value[AnIdx];
   else return 0;
}
//---------------------------------------------------------------------------

Variant __fastcall TForm1::ExParser1Function(TObject *Sender,
      const AnsiString FuncName, const ArgArray &FuncParams,
      const int Param_High)
{
   Double Result = 0;
   if (CompareText(FuncName, "MyFunc")==0)
      Result=(Double)FuncParams[0]*(Double)FuncParams[1]+(Double)FuncParams[2];
   else if (CompareText(FuncName, "MyFunc1")==0)
      Result=pow((Double)FuncParams[0],2)+(Double)FuncParams[1];
   else if (CompareText(FuncName, "MySumFunc")==0)
     for (int i=0; i<=Param_High; i++) Result += (Double)FuncParams[i];
   else
     throw Exception("Unknown function name: "+FuncName);
   return Result;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
   TUsedVarsEditDlg *ADlg;
   ExParser1->Expression->Assign(Memo1->Lines);
   ADlg = new TUsedVarsEditDlg(this);
   try
     {
     ADlg->AnExParser=ExParser1;
     ADlg->ShowModal();
     }
   __finally { delete ADlg; };
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
  ResultLbl->Caption="0"; ResultLbl2->Caption="";
  EPVars1->Variables["x1"]->Value = 4;
  EPVars1->Variables["y1"]->Value = 3;
  AddUserLibExpr(EPUserLib1->Aliases,"x","%0");
  EPUserLib1->Aliases->AddExpr("y","%1");
  EPUserLib1->Aliases->AddExpr("z","%2");
  EPUserLib1->UserFuncs->AddExpr("LibFunc1","x + y^3");
  EPUserLib1->UserFuncs->AddExpr("LibFunc2","LibFunc1(x,y)^2");
  Memo1->Lines->Clear();
  Memo1->Lines->Add("x1 ^ y1 + MySum(MyFunc(x,y,z),MyFunc(x+4,y+1,z+9),");
  Memo1->Lines->Add("prod(x2,y2),MyFunc1(x2,y2),LibFunc2(x2,y2),x3^y3)");
  DescrLbl->Caption="A complex single line expression demo, that uses function arguments, user defined library"
                    " functions and aliases, variables and registered math procedure. "
                    " You can try to load other definitions for library functions from INI file.";
}
//----------------------------------------------------------------------------
void __fastcall TForm1::Button7Click(TObject *Sender)
{
  ResultLbl->Caption="0"; ResultLbl2->Caption="";
  Memo1->Lines->Clear();
  Memo1->Lines->Add("ACount:=0;");
  Memo1->Lines->Add("Result:=0;");
  Memo1->Lines->Add("ATbl:=[TTable].Create([Self]);");
  Memo1->Lines->Add("try");
  Memo1->Lines->Add("  ATbl.DatabaseName:=\"DEMODB\"; ATbl.TableName:=\"ValTbl.DB\";");
  Memo1->Lines->Add("  ATbl.IndexFieldNames:=\"RecNo\";");
  Memo1->Lines->Add("  ATbl.Open; ATbl.First;");
  Memo1->Lines->Add("  while Not ATbl.EOF do begin");
  Memo1->Lines->Add("    Result:=Result+ATbl.FieldByName(\"Value\").AsFloat;");
  Memo1->Lines->Add("    ACount:=ACount+1;");
  Memo1->Lines->Add("    ATbl.Next;");
  Memo1->Lines->Add("  end;");
  Memo1->Lines->Add("finally");
  Memo1->Lines->Add("  ATbl.Free;");
  Memo1->Lines->Add("end;");
  Memo1->Lines->Add("[ResultLbl2].Caption:=ACount;");
  DescrLbl->Caption="This demo shows how to create components and use of runtime components, class references," \
                    " while loop, 'try finally end' statement. You can use BREAK to break the loop.";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
   ResultLbl->Caption="0"; ResultLbl2->Caption="";
   Memo1->Lines->Clear();
   Memo1->Lines->Add("Sum:=0; K:=3;");
   Memo1->Lines->Add("if k<5 then");
   Memo1->Lines->Add("  for I:=0 to 30 do begin");
   Memo1->Lines->Add("    if (I>=0) and (I<5) then Sum:=Sum+3");
   Memo1->Lines->Add("    else if (I>=5) and (I<20) then Sum:=Sum+5");
   Memo1->Lines->Add("    else if (I>=20) and (I<=30) then Sum:=Sum+10;");
   Memo1->Lines->Add("  end");
   Memo1->Lines->Add("else if k<10 then begin");
   Memo1->Lines->Add("  I:=0;");
   Memo1->Lines->Add("  repeat");
   Memo1->Lines->Add("    if (I>=0) and (I<10) then Sum:=Sum+4");
   Memo1->Lines->Add("    else if (I>=10) and (I<20) then Sum:=Sum+5");
   Memo1->Lines->Add("    else if (I>=20) and (I<=30) then Sum:=Sum+6;");
   Memo1->Lines->Add("    Inc(I);");
   Memo1->Lines->Add("  until I>30;");
   Memo1->Lines->Add("end else begin");
   Memo1->Lines->Add("  I:=0;");
   Memo1->Lines->Add("  while I<=30 do begin");
   Memo1->Lines->Add("    Sum:=Sum+10;");
   Memo1->Lines->Add("    Inc(I);");
   Memo1->Lines->Add("  end;");
   Memo1->Lines->Add("end;");
   Memo1->Lines->Add("Result:=Sum;");
   Memo1->Lines->Add("ShowResult([ResultLbl2],I);");
   DescrLbl->Caption="This demo is a complex script that uses many nested 'if then else' statements and loops. " \
                     "Also shows how to use registered runtime function of object (ShowResult)";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button9Click(TObject *Sender)
{
   TVariable *AVar=EPVars1->Variables["RTVar"];
   ResultLbl->Caption="0"; ResultLbl2->Caption="";
   AVar->Descr="A link to a runtime variable";
   AVar->LinkTo(&InitVal);
   Memo1->Lines->Clear();
   Memo1->Lines->Add("I:=MyPROD(RTVar,4,5);");
   Memo1->Lines->Add("Result:=MySUM(3,Var1,5,MyAVG(2,3,4,5));");
   Memo1->Lines->Add("ShowResult([ResultLbl2], I);");
   DescrLbl->Caption="This is an example of using a runtime variables and registered functions, and 'on event' " \
                      "evaluated variables and registered functions.";
}

//---------------------------------------------------------------------------

void __fastcall TForm1::Button10Click(TObject *Sender)
{
   ResultLbl->Caption = "0"; ResultLbl2->Caption = "";
   Memo1->Lines->Clear();
   Memo1->Lines->Add("Excel:=CreateOleObject(\"Excel.Application\");");
   Memo1->Lines->Add("Excel.Visible:=True;");
   Memo1->Lines->Add("WBook:=Excel.WorkBooks.Add;");
   Memo1->Lines->Add("ASheet:=WBook.Sheets.Item(1);");
   Memo1->Lines->Add("ASheet.Activate;");
   Memo1->Lines->Add("Randomize();");
   Memo1->Lines->Add("for I:=1 to 5 do");
   Memo1->Lines->Add("  ASheet.Cells.Item(2,I).Value:=Random(10);");
   Memo1->Lines->Add("Ch:=ASheet.ChartObjects.Add(10,50,250,150);");
   Memo1->Lines->Add("xl3DColumn:=$FFFFEFFC;");
   Memo1->Lines->Add("Ch.Chart.ChartWizard(ASheet.Range(\"A2:E2\"),xl3DColumn,");
   Memo1->Lines->Add("      Unassigned,Unassigned,Unassigned,Unassigned,False);");
   Memo1->Lines->Add("ShowMessage(\"OK\");");
   DescrLbl->Caption = "This is an example of using OLE Automation objects.";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button11Click(TObject *Sender)
{
   ResultLbl->Caption="0"; ResultLbl2->Caption="";
   EPUserLib1->UserFuncs->ClearEntries();
   EPUserLib1->UserFuncs->AddExpr("DemoLibFunc","%0+%1");
   Memo1->Lines->Clear();
   Memo1->Lines->Add("SS:=\"Format(\"\"%4.4d\"\",Integer((%0+2*%1)*3))\";");
   Memo1->Lines->Add("I:=DemoFunc(2,3);");
   Memo1->Lines->Add("Result:=ExecScript(SS,2,I);");
   DescrLbl->Caption="This example shows how to execute a script defined during evaluation and " \
                     "how to call a user defined script function from a program (DemoFunc).";
}
//---------------------------------------------------------------------------

